require 'cgi'
require 'cgi/session'

class CGI #:nodoc:all
  class Session
    class JavaServletStore

      def initialize(session, option=nil)
      	@java_request = option['java_request'] if option
      	unless @java_request
      		raise 'JavaServletStore requires that HttpServletRequest is made available to the session'
      	end
      	@session_data = {}
      end

      # Restore session state from the Java session
      def restore
        @session_data = {}
        java_session = @java_request.getSession(false)
        if java_session
          names = java_session.getAttributeNames
          while names.hasMoreElements
            name = names.nextElement
            @session_data[name] = java_session.getAttribute(name)
          end
        end
        @session_data
      end

      # Save session state to the Java session
      def update
        java_session = @java_request.getSession(true)
        for key, value in @session_data
          java_session.setAttribute(key.to_s, value)
        end
      end

      # Update and close the Java session entry
      def close
        update
      end

      # Delete the Java session entry
      def delete
        java_session = @java_request.getSession(false)
        java_session.invalidate if java_session
      end

      # The session state
      def data
        @session_data
      end

    end
  end
end
